git-rebase.shon commit mergetool: Remove explicit references to /dev/tty (af31471)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37LF='
  38'
  39OK_TO_SKIP_PRE_REBASE=
  40RESOLVEMSG="
  41When you have resolved this problem run \"git rebase --continue\".
  42If you would prefer to skip this patch, instead run \"git rebase --skip\".
  43To restore the original branch and stop rebasing run \"git rebase --abort\".
  44"
  45unset newbase
  46strategy=recursive
  47do_merge=
  48dotest="$GIT_DIR"/rebase-merge
  49prec=4
  50verbose=
  51diffstat=$(git config --bool rebase.stat)
  52git_am_opt=
  53rebase_root=
  54force_rebase=
  55allow_rerere_autoupdate=
  56
  57continue_merge () {
  58        test -n "$prev_head" || die "prev_head must be defined"
  59        test -d "$dotest" || die "$dotest directory does not exist"
  60
  61        unmerged=$(git ls-files -u)
  62        if test -n "$unmerged"
  63        then
  64                echo "You still have unmerged paths in your index"
  65                echo "did you forget to use git add?"
  66                die "$RESOLVEMSG"
  67        fi
  68
  69        cmt=`cat "$dotest/current"`
  70        if ! git diff-index --quiet --ignore-submodules HEAD --
  71        then
  72                if ! git commit --no-verify -C "$cmt"
  73                then
  74                        echo "Commit failed, please do not call \"git commit\""
  75                        echo "directly, but instead do one of the following: "
  76                        die "$RESOLVEMSG"
  77                fi
  78                if test -z "$GIT_QUIET"
  79                then
  80                        printf "Committed: %0${prec}d " $msgnum
  81                fi
  82                echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
  83        else
  84                if test -z "$GIT_QUIET"
  85                then
  86                        printf "Already applied: %0${prec}d " $msgnum
  87                fi
  88        fi
  89        test -z "$GIT_QUIET" &&
  90        GIT_PAGER='' git log --format=%s -1 "$cmt"
  91
  92        prev_head=`git rev-parse HEAD^0`
  93        # save the resulting commit so we can read-tree on it later
  94        echo "$prev_head" > "$dotest/prev_head"
  95
  96        # onto the next patch:
  97        msgnum=$(($msgnum + 1))
  98        echo "$msgnum" >"$dotest/msgnum"
  99}
 100
 101call_merge () {
 102        cmt="$(cat "$dotest/cmt.$1")"
 103        echo "$cmt" > "$dotest/current"
 104        hd=$(git rev-parse --verify HEAD)
 105        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
 106        msgnum=$(cat "$dotest/msgnum")
 107        end=$(cat "$dotest/end")
 108        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
 109        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
 110        export GITHEAD_$cmt GITHEAD_$hd
 111        if test -n "$GIT_QUIET"
 112        then
 113                export GIT_MERGE_VERBOSITY=1
 114        fi
 115        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
 116        rv=$?
 117        case "$rv" in
 118        0)
 119                unset GITHEAD_$cmt GITHEAD_$hd
 120                return
 121                ;;
 122        1)
 123                git rerere $allow_rerere_autoupdate
 124                die "$RESOLVEMSG"
 125                ;;
 126        2)
 127                echo "Strategy: $rv $strategy failed, try another" 1>&2
 128                die "$RESOLVEMSG"
 129                ;;
 130        *)
 131                die "Unknown exit code ($rv) from command:" \
 132                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 133                ;;
 134        esac
 135}
 136
 137move_to_original_branch () {
 138        test -z "$head_name" &&
 139                head_name="$(cat "$dotest"/head-name)" &&
 140                onto="$(cat "$dotest"/onto)" &&
 141                orig_head="$(cat "$dotest"/orig-head)"
 142        case "$head_name" in
 143        refs/*)
 144                message="rebase finished: $head_name onto $onto"
 145                git update-ref -m "$message" \
 146                        $head_name $(git rev-parse HEAD) $orig_head &&
 147                git symbolic-ref HEAD $head_name ||
 148                die "Could not move back to $head_name"
 149                ;;
 150        esac
 151}
 152
 153finish_rb_merge () {
 154        move_to_original_branch
 155        git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 156        if test -x "$GIT_DIR"/hooks/post-rewrite &&
 157                test -s "$dotest"/rewritten; then
 158                "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 159        fi
 160        rm -r "$dotest"
 161        say All done.
 162}
 163
 164is_interactive () {
 165        while test $# != 0
 166        do
 167                case "$1" in
 168                        -i|--interactive)
 169                                interactive_rebase=explicit
 170                                break
 171                        ;;
 172                        -p|--preserve-merges)
 173                                interactive_rebase=implied
 174                        ;;
 175                esac
 176                shift
 177        done
 178
 179        if [ "$interactive_rebase" = implied ]; then
 180                GIT_EDITOR=:
 181                export GIT_EDITOR
 182        fi
 183
 184        test -n "$interactive_rebase" || test -f "$dotest"/interactive
 185}
 186
 187run_pre_rebase_hook () {
 188        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 189           test -x "$GIT_DIR/hooks/pre-rebase"
 190        then
 191                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 192                die "The pre-rebase hook refused to rebase."
 193        fi
 194}
 195
 196test -f "$GIT_DIR"/rebase-apply/applying &&
 197        die 'It looks like git-am is in progress. Cannot rebase.'
 198
 199is_interactive "$@" && exec git-rebase--interactive "$@"
 200
 201while test $# != 0
 202do
 203        case "$1" in
 204        --no-verify)
 205                OK_TO_SKIP_PRE_REBASE=yes
 206                ;;
 207        --continue)
 208                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 209                        die "No rebase in progress?"
 210
 211                git diff-files --quiet --ignore-submodules || {
 212                        echo "You must edit all merge conflicts and then"
 213                        echo "mark them as resolved using git add"
 214                        exit 1
 215                }
 216                if test -d "$dotest"
 217                then
 218                        prev_head=$(cat "$dotest/prev_head")
 219                        end=$(cat "$dotest/end")
 220                        msgnum=$(cat "$dotest/msgnum")
 221                        onto=$(cat "$dotest/onto")
 222                        GIT_QUIET=$(cat "$dotest/quiet")
 223                        continue_merge
 224                        while test "$msgnum" -le "$end"
 225                        do
 226                                call_merge "$msgnum"
 227                                continue_merge
 228                        done
 229                        finish_rb_merge
 230                        exit
 231                fi
 232                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 233                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 234                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 235                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 236                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 237                move_to_original_branch
 238                exit
 239                ;;
 240        --skip)
 241                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 242                        die "No rebase in progress?"
 243
 244                git reset --hard HEAD || exit $?
 245                if test -d "$dotest"
 246                then
 247                        git rerere clear
 248                        prev_head=$(cat "$dotest/prev_head")
 249                        end=$(cat "$dotest/end")
 250                        msgnum=$(cat "$dotest/msgnum")
 251                        msgnum=$(($msgnum + 1))
 252                        onto=$(cat "$dotest/onto")
 253                        GIT_QUIET=$(cat "$dotest/quiet")
 254                        while test "$msgnum" -le "$end"
 255                        do
 256                                call_merge "$msgnum"
 257                                continue_merge
 258                        done
 259                        finish_rb_merge
 260                        exit
 261                fi
 262                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 263                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 264                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 265                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 266                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 267                move_to_original_branch
 268                exit
 269                ;;
 270        --abort)
 271                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 272                        die "No rebase in progress?"
 273
 274                git rerere clear
 275                if test -d "$dotest"
 276                then
 277                        GIT_QUIET=$(cat "$dotest/quiet")
 278                        move_to_original_branch
 279                else
 280                        dotest="$GIT_DIR"/rebase-apply
 281                        GIT_QUIET=$(cat "$dotest/quiet")
 282                        move_to_original_branch
 283                fi
 284                git reset --hard $(cat "$dotest/orig-head")
 285                rm -r "$dotest"
 286                exit
 287                ;;
 288        --onto)
 289                test 2 -le "$#" || usage
 290                newbase="$2"
 291                shift
 292                ;;
 293        -M|-m|--m|--me|--mer|--merg|--merge)
 294                do_merge=t
 295                ;;
 296        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 297                --strateg=*|--strategy=*|\
 298        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 299                case "$#,$1" in
 300                *,*=*)
 301                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 302                1,*)
 303                        usage ;;
 304                *)
 305                        strategy="$2"
 306                        shift ;;
 307                esac
 308                do_merge=t
 309                ;;
 310        -n|--no-stat)
 311                diffstat=
 312                ;;
 313        --stat)
 314                diffstat=t
 315                ;;
 316        -v|--verbose)
 317                verbose=t
 318                diffstat=t
 319                GIT_QUIET=
 320                ;;
 321        -q|--quiet)
 322                GIT_QUIET=t
 323                git_am_opt="$git_am_opt -q"
 324                verbose=
 325                diffstat=
 326                ;;
 327        --whitespace=*)
 328                git_am_opt="$git_am_opt $1"
 329                case "$1" in
 330                --whitespace=fix|--whitespace=strip)
 331                        force_rebase=t
 332                        ;;
 333                esac
 334                ;;
 335        --ignore-whitespace)
 336                git_am_opt="$git_am_opt $1"
 337                ;;
 338        --committer-date-is-author-date|--ignore-date)
 339                git_am_opt="$git_am_opt $1"
 340                force_rebase=t
 341                ;;
 342        -C*)
 343                git_am_opt="$git_am_opt $1"
 344                ;;
 345        --root)
 346                rebase_root=t
 347                ;;
 348        -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
 349                force_rebase=t
 350                ;;
 351        --rerere-autoupdate|--no-rerere-autoupdate)
 352                allow_rerere_autoupdate="$1"
 353                ;;
 354        -*)
 355                usage
 356                ;;
 357        *)
 358                break
 359                ;;
 360        esac
 361        shift
 362done
 363test $# -gt 2 && usage
 364
 365if test $# -eq 0 && test -z "$rebase_root"
 366then
 367        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 368        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 369                die 'A rebase is in progress, try --continue, --skip or --abort.'
 370fi
 371
 372# Make sure we do not have $GIT_DIR/rebase-apply
 373if test -z "$do_merge"
 374then
 375        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 376        then
 377                rmdir "$GIT_DIR"/rebase-apply
 378        else
 379                echo >&2 '
 380It seems that I cannot create a rebase-apply directory, and
 381I wonder if you are in the middle of patch application or another
 382rebase.  If that is not the case, please
 383        rm -fr '"$GIT_DIR"'/rebase-apply
 384and run me again.  I am stopping in case you still have something
 385valuable there.'
 386                exit 1
 387        fi
 388else
 389        if test -d "$dotest"
 390        then
 391                die "previous rebase directory $dotest still exists." \
 392                        'Try git rebase (--continue | --abort | --skip)'
 393        fi
 394fi
 395
 396# The tree must be really really clean.
 397if ! git update-index --ignore-submodules --refresh > /dev/null; then
 398        echo >&2 "cannot rebase: you have unstaged changes"
 399        git diff-files --name-status -r --ignore-submodules -- >&2
 400        exit 1
 401fi
 402diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 403case "$diff" in
 404?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
 405        echo >&2 "$diff"
 406        exit 1
 407        ;;
 408esac
 409
 410if test -z "$rebase_root"
 411then
 412        # The upstream head must be given.  Make sure it is valid.
 413        upstream_name="$1"
 414        shift
 415        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 416        die "invalid upstream $upstream_name"
 417        unset root_flag
 418        upstream_arg="$upstream_name"
 419else
 420        test -z "$newbase" && die "--root must be used with --onto"
 421        unset upstream_name
 422        unset upstream
 423        root_flag="--root"
 424        upstream_arg="$root_flag"
 425fi
 426
 427# Make sure the branch to rebase onto is valid.
 428onto_name=${newbase-"$upstream_name"}
 429case "$onto_name" in
 430*...*)
 431        if      left=${onto_name%...*} right=${onto_name#*...} &&
 432                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 433        then
 434                case "$onto" in
 435                ?*"$LF"?*)
 436                        die "$onto_name: there are more than one merge bases"
 437                        ;;
 438                '')
 439                        die "$onto_name: there is no merge base"
 440                        ;;
 441                esac
 442        else
 443                die "$onto_name: there is no merge base"
 444        fi
 445        ;;
 446*)
 447        onto=$(git rev-parse --verify "${onto_name}^0") || exit
 448        ;;
 449esac
 450
 451# If a hook exists, give it a chance to interrupt
 452run_pre_rebase_hook "$upstream_arg" "$@"
 453
 454# If the branch to rebase is given, that is the branch we will rebase
 455# $branch_name -- branch being rebased, or HEAD (already detached)
 456# $orig_head -- commit object name of tip of the branch before rebasing
 457# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 458switch_to=
 459case "$#" in
 4601)
 461        # Is it "rebase other $branchname" or "rebase other $commit"?
 462        branch_name="$1"
 463        switch_to="$1"
 464
 465        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 466           branch=$(git rev-parse -q --verify "refs/heads/$1")
 467        then
 468                head_name="refs/heads/$1"
 469        elif branch=$(git rev-parse -q --verify "$1")
 470        then
 471                head_name="detached HEAD"
 472        else
 473                usage
 474        fi
 475        ;;
 476*)
 477        # Do not need to switch branches, we are already on it.
 478        if branch_name=`git symbolic-ref -q HEAD`
 479        then
 480                head_name=$branch_name
 481                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 482        else
 483                head_name="detached HEAD"
 484                branch_name=HEAD ;# detached
 485        fi
 486        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 487        ;;
 488esac
 489orig_head=$branch
 490
 491# Now we are rebasing commits $upstream..$branch (or with --root,
 492# everything leading up to $branch) on top of $onto
 493
 494# Check if we are already based on $onto with linear history,
 495# but this should be done only when upstream and onto are the same.
 496mb=$(git merge-base "$onto" "$branch")
 497if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 498        # linear history?
 499        ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
 500then
 501        if test -z "$force_rebase"
 502        then
 503                # Lazily switch to the target branch if needed...
 504                test -z "$switch_to" || git checkout "$switch_to"
 505                say "Current branch $branch_name is up to date."
 506                exit 0
 507        else
 508                say "Current branch $branch_name is up to date, rebase forced."
 509        fi
 510fi
 511
 512# Detach HEAD and reset the tree
 513say "First, rewinding head to replay your work on top of it..."
 514git checkout -q "$onto^0" || die "could not detach HEAD"
 515git update-ref ORIG_HEAD $branch
 516
 517if test -n "$diffstat"
 518then
 519        if test -n "$verbose"
 520        then
 521                echo "Changes from $mb to $onto:"
 522        fi
 523        # We want color (if set), but no pager
 524        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 525fi
 526
 527# If the $onto is a proper descendant of the tip of the branch, then
 528# we just fast-forwarded.
 529if test "$mb" = "$branch"
 530then
 531        say "Fast-forwarded $branch_name to $onto_name."
 532        move_to_original_branch
 533        exit 0
 534fi
 535
 536if test -n "$rebase_root"
 537then
 538        revisions="$onto..$orig_head"
 539else
 540        revisions="$upstream..$orig_head"
 541fi
 542
 543if test -z "$do_merge"
 544then
 545        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 546                $root_flag "$revisions" |
 547        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 548        move_to_original_branch
 549        ret=$?
 550        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 551                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 552                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 553                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
 554                echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
 555        exit $ret
 556fi
 557
 558# start doing a rebase with git-merge
 559# this is rename-aware if the recursive (default) strategy is used
 560
 561mkdir -p "$dotest"
 562echo "$onto" > "$dotest/onto"
 563echo "$onto_name" > "$dotest/onto_name"
 564prev_head=$orig_head
 565echo "$prev_head" > "$dotest/prev_head"
 566echo "$orig_head" > "$dotest/orig-head"
 567echo "$head_name" > "$dotest/head-name"
 568echo "$GIT_QUIET" > "$dotest/quiet"
 569
 570msgnum=0
 571for cmt in `git rev-list --reverse --no-merges "$revisions"`
 572do
 573        msgnum=$(($msgnum + 1))
 574        echo "$cmt" > "$dotest/cmt.$msgnum"
 575done
 576
 577echo 1 >"$dotest/msgnum"
 578echo $msgnum >"$dotest/end"
 579
 580end=$msgnum
 581msgnum=1
 582
 583while test "$msgnum" -le "$end"
 584do
 585        call_merge "$msgnum"
 586        continue_merge
 587done
 588
 589finish_rb_merge